/*
 * Copyright (C) 2003, 2004 Bjrn-Ove Heimsund
 * 
 * This file is part of MT.
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation; either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package mt.test;

import mt.DenseMatrix;
import mt.Matrix;
import mt.fact.LQComputer;
import mt.fact.OrthogonalDecomposition;

/**
 * LQ test
 */
public class LQTest extends OrthogonalTest {

	public LQTest(String arg0) {
		super(arg0);
	}

	public void testStaticFactorize() {
		assertEquals(A, LQComputer.factorize(A));
	}

	public void testRepeatStaticFactorize() {
		assertEquals(A, LQComputer.factorize(A));
		assertEquals(A, LQComputer.factorize(A));
	}

	public void testFactor() {
		LQComputer c = new LQComputer(A.numRows(), A.numColumns());
		assertEquals(A, c.factor(A.copy()));
	}

	public void testRepeatFactor() {
		LQComputer c = new LQComputer(A.numRows(), A.numColumns());
		OrthogonalDecomposition od = c.factor(A.copy());
		assertEquals(A, od);
		od = c.factor(A.copy());
		assertEquals(A, od);
	}

	private void assertEquals(Matrix A, OrthogonalDecomposition od) {
		assertEquals(
			A,
			od.getL().mult(
				od.getQ().generate(),
				new DenseMatrix(A.numRows(), A.numColumns())));
	}

}
